#!/usr/bin/env bash

BASEDIR=$(dirname "$0")
TARGETDIR="$BASEDIR/../content/shaders"
GLSL="glslc"

rm $TARGETDIR/*.spv

# Tris
$GLSL $BASEDIR/Tris.vert -o $TARGETDIR/Tris.vs.spv
$GLSL $BASEDIR/Tris.frag -o $TARGETDIR/Tris.fs.spv
$GLSL $BASEDIR/Tris.vert $BASEDIR/Tris.frag -o $TARGETDIR/Tris.spv

# Color
$GLSL $BASEDIR/Color.vert -o $TARGETDIR/Color.vs.spv
$GLSL $BASEDIR/Color.frag -o $TARGETDIR/Color.fs.spv

# Sky
$GLSL $BASEDIR/Sky.vert -o $TARGETDIR/Sky.vs.spv
$GLSL $BASEDIR/Sky.frag -o $TARGETDIR/Sky.fs.spv

# Voxel
$GLSL $BASEDIR/Voxel.vert -o $TARGETDIR/Voxel.vs.spv
$GLSL $BASEDIR/Voxel.frag -o $TARGETDIR/Voxel.fs.spv
$GLSL $BASEDIR/Voxel.vert -DINSTANCED -o $TARGETDIR/Voxel.vs.ins.spv
$GLSL $BASEDIR/Voxel.frag -DINSTANCED -o $TARGETDIR/Voxel.fs.ins.spv

$GLSL $BASEDIR/Voxel.vert -DGEOMETRY -o $TARGETDIR/Voxel.vs.geo.spv
$GLSL $BASEDIR/Voxel.geom -DGEOMETRY -o $TARGETDIR/Voxel.gs.geo.spv
$GLSL $BASEDIR/Voxel.frag -DGEOMETRY -o $TARGETDIR/Voxel.fs.geo.spv
$GLSL $BASEDIR/Voxel.vert -DGEOMETRY -DINSTANCED -o $TARGETDIR/Voxel.vs.geo.ins.spv
$GLSL $BASEDIR/Voxel.geom -DGEOMETRY -DINSTANCED -o $TARGETDIR/Voxel.gs.geo.ins.spv
$GLSL $BASEDIR/Voxel.frag -DGEOMETRY -DINSTANCED -o $TARGETDIR/Voxel.fs.geo.ins.spv